(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    147249,       4212]
NotebookOptionsPosition[    133148,       3974]
NotebookOutlinePosition[    133504,       3990]
CellTagsIndexPosition[    133461,       3987]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\
Boolean Correlations: used in Sections 4 and 6 of M.Sc. course\
\>", "Section",
 CellChangeTimes->{{3.785150237723134*^9, 
  3.785150247451522*^9}},ExpressionUUID->"ae22d33f-1f22-44fa-8417-\
0e0d9f552085"],

Cell[TextData[StyleBox["Use \[OpenCurlyQuote] Evaluate Notebook\
\[CloseCurlyQuote] in \[OpenCurlyQuote] Evaluation\[CloseCurlyQuote] menu to \
get everything loaded (blue text should change to black, this will take a few \
seconds). ",
 FontWeight->"Bold",
 FontSlant->"Italic"]], "Subsection",
 CellChangeTimes->{{3.785150255537223*^9, 
  3.7851502677074337`*^9}},ExpressionUUID->"b9c93934-07a6-4940-8a19-\
27da951d267e"],

Cell[CellGroupData[{

Cell["Preliminaries", "Subsection",
 CellChangeTimes->{{3.785150250989551*^9, 
  3.785150273388726*^9}},ExpressionUUID->"a39d5536-b698-40e6-a709-\
a52766484602"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TF", "[", "xs_", "]"}], ":=", 
  RowBox[{"TableForm", "[", 
   RowBox[{"xs", ",", 
    RowBox[{"TableDepth", "\[Rule]", "2"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.78211976986726*^9, 3.7821197756637497`*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"e427eb19-7eb2-4d44-8247-9676f2f20856"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BinaryWords", "[", "0", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"{", "}"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.7206976718967533`*^9, 3.720697683912755*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"9f22a1c1-538c-4919-a2f6-a7b7616b2e42"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BinaryWords", "[", "n_", "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", "0", "}"}], "~", "Join", "~", "w"}], ",", 
     RowBox[{"{", 
      RowBox[{"w", ",", 
       RowBox[{"BinaryWords", "[", 
        RowBox[{"n", "-", "1"}], "]"}]}], "}"}]}], "]"}], "~", "Join", "~", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", "1", "}"}], "~", "Join", "~", "w"}], ",", 
     RowBox[{"{", 
      RowBox[{"w", ",", 
       RowBox[{"BinaryWords", "[", 
        RowBox[{"n", "-", "1"}], "]"}]}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7206976847174892`*^9, 3.720697726585409*^9}, 
   3.720697912405882*^9},
 CellLabel->"In[3]:=",ExpressionUUID->"2c0d92d4-d2af-4017-a58a-692abe861c9e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TruthTable", "[", 
   RowBox[{"n_", ",", "fs__List"}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"w", ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"f", "[", "w", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"f", ",", "fs"}], "}"}]}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"w", ",", 
      RowBox[{"BinaryWords", "[", "n", "]"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.720698529395352*^9, 3.72069855043633*^9}, {
   3.720698596933831*^9, 3.720698655076336*^9}, {3.7208741533174133`*^9, 
   3.7208741552744217`*^9}, {3.720874251237194*^9, 3.7208742572253237`*^9}, {
   3.720874365076459*^9, 3.720874368413926*^9}, 3.720874653373518*^9, {
   3.720875510354823*^9, 3.7208755395539007`*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"25b08814-6103-41b8-b6ea-6806b910cd38"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TruthTable", "[", 
   RowBox[{"n_", ",", "f_"}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"w", ",", 
      RowBox[{"f", "[", "w", "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"w", ",", 
      RowBox[{"BinaryWords", "[", "n", "]"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.720698635176033*^9, 3.72069866978098*^9}, {
   3.7208741671411533`*^9, 3.720874168664585*^9}, {3.720874241166993*^9, 
   3.720874247370343*^9}, {3.7208743702662277`*^9, 3.720874508558125*^9}, {
   3.720874584809219*^9, 3.720874587494774*^9}, {3.7208746264512*^9, 
   3.720874638795416*^9}, {3.720875544868073*^9, 3.720875553236397*^9}, 
   3.720875729285705*^9},
 CellLabel->"In[5]:=",ExpressionUUID->"a61b1368-e3fc-45f1-a664-9803fea546f2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Mod2", "[", "x_", "]"}], ":=", 
  RowBox[{"Mod", "[", 
   RowBox[{"x", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7821485206963453`*^9, 3.782148524627108*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"2291904e-025b-47af-ac2b-dc5abaad8f6e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MF", "[", "xs_", "]"}], ":=", 
  RowBox[{"MatrixForm", "[", "xs", "]"}]}]], "Input",
 CellChangeTimes->{{3.785140146620072*^9, 3.785140150378387*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"b30ba8c5-3237-45f0-8155-448144a83488"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SubsetsRLex", "[", 
   RowBox[{"{", "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"{", "}"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.78514019619491*^9, 3.785140208405991*^9}, 
   3.7851403576889887`*^9},
 CellLabel->"In[8]:=",ExpressionUUID->"583c4e71-8ba9-4a43-9851-d31003bded6c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SubsetsRLex", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "xs___"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"SubsetsRLex", "[", 
    RowBox[{"xs", "//", "List"}], "]"}], "~", "Join", "~", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", "x", "}"}], "~", "Join", "~", "s"}], ",", 
     RowBox[{"{", 
      RowBox[{"s", ",", 
       RowBox[{"SubsetsRLex", "[", 
        RowBox[{"xs", "//", "List"}], "]"}]}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.785140209414569*^9, 3.785140359425088*^9}, {
  3.78514039354943*^9, 3.785140394835616*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"8c3e8b2e-29ba-4577-98f1-f0cae9f3872c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Reverse", "/@", 
  RowBox[{"SubsetsRLex", "[", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "0"}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.785140391419788*^9, 3.785140421026865*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"b9f9614d-3896-4772-a98f-ee0f0968f1a1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "0", "}"}], ",", 
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "2", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.7851404029865217`*^9, 3.785140421500443*^9}, 
   3.785140456971534*^9, 3.78514059565628*^9, 3.785232045358653*^9, 
   3.7852567485905943`*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"a483f38c-b1c1-42bd-96e3-278d61259e2b"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"SubsetsLex", "[", "xs_", "]"}], ":=", 
  RowBox[{"Reverse", "/@", 
   RowBox[{"SubsetsRLex", "[", 
    RowBox[{"Reverse", "[", "xs", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.785140362837884*^9, 3.785140374777849*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"8b7e58d2-eb0f-43cb-93de-cfd25fd04f4c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ModTwo", "[", "xs_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"Mod", "[", 
     RowBox[{"#", ",", "2"}], "]"}], "&"}], "/@", "xs"}]}]], "Input",
 CellChangeTimes->{{3.7851408270254498`*^9, 3.785140835446867*^9}, {
  3.785253536017931*^9, 3.785253546440475*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"1cb12a99-5d70-4935-9f96-64ad2cb9aff9"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Correlation for Boolean functions", "Section",
 CellChangeTimes->{{3.782148403234703*^9, 3.78214842547114*^9}, {
  3.785150230842638*^9, 
  3.785150232391417*^9}},ExpressionUUID->"c801f799-a4d7-4f83-984f-\
f401215ed901"],

Cell[CellGroupData[{

Cell["\<\
Linear functions L_T for T a subset of {0,...,-1}: e.g. L_{1,2}[{x,y,z}] -> \
y+z\
\>", "Subsection",
 CellChangeTimes->{{3.7206961774289503`*^9, 3.720696203589672*^9}, {
  3.7206984211800537`*^9, 3.720698441935458*^9}, {3.7821199331167192`*^9, 
  3.78211994213301*^9}},ExpressionUUID->"4ab90683-c46d-4c9c-be7e-\
a12fa4ad2260"],

Cell[BoxData[
 RowBox[{
  RowBox[{"L", "[", "T_", "]"}], ":=", " ", 
  RowBox[{"Function", "[", 
   RowBox[{"x", ",", 
    RowBox[{
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{"x", "[", 
        RowBox[{"[", 
         RowBox[{"t", "+", "1"}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "T"}], "}"}]}], "]"}], "//", "Mod2"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.720696188955029*^9, 3.720696213376876*^9}, {
  3.720696248983822*^9, 3.720696251583987*^9}, {3.7206978202192593`*^9, 
  3.7206978425801973`*^9}, {3.720874720532455*^9, 3.720874721356*^9}, {
  3.720874807410082*^9, 3.720874888177225*^9}, {3.720874927964395*^9, 
  3.720874936237742*^9}, {3.7208752771047*^9, 3.7208752885126877`*^9}, {
  3.720875359583795*^9, 3.720875363950617*^9}, {3.720875593007918*^9, 
  3.720875594122506*^9}, {3.7208758841016903`*^9, 3.7208759621378803`*^9}, {
  3.782119850906361*^9, 3.782119851057851*^9}},
 CellLabel->"In[13]:=",ExpressionUUID->"8ffe7ced-fc0c-4f3a-90e5-04522b1db34f"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Correlation", "Subsection",
 CellChangeTimes->{{3.720696253790307*^9, 
  3.720696258014901*^9}},ExpressionUUID->"5e9c0adc-f309-429b-afdf-\
f4c4fa4fbe0b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Corr", "[", 
   RowBox[{"n_", ",", "f_", ",", "g_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"1", "/", 
    RowBox[{"2", "^", "n"}]}], "*", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], "^", 
       RowBox[{"f", "[", "xs", "]"}]}], "*", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], "^", 
       RowBox[{"g", "[", "xs", "]"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"xs", ",", 
       RowBox[{"BinaryWords", "[", "n", "]"}]}], "}"}]}], "]"}]}]}]], "Input",\

 CellChangeTimes->{{3.720697524016432*^9, 3.720697556169083*^9}, {
  3.7206976603030853`*^9, 3.720697668325458*^9}, {3.720698869409587*^9, 
  3.720698876534218*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"f119b5df-b400-4958-9f3f-c5fbaf0592d8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Correlations", "[", 
   RowBox[{"n_", ",", "f_"}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"T", ",", 
      RowBox[{"Corr", "[", 
       RowBox[{"n", ",", "f", ",", 
        RowBox[{"L", "[", "T", "]"}]}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"T", ",", 
      RowBox[{"Subsets", "[", 
       RowBox[{"Range", "[", 
        RowBox[{"0", ",", 
         RowBox[{"n", "-", "1"}]}], "]"}], "]"}]}], "}"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.7206978034977293`*^9, 3.720697818180066*^9}, {
  3.720697873704508*^9, 3.720697893643569*^9}, {3.782119801850603*^9, 
  3.782119809473825*^9}, {3.782119858493437*^9, 3.782119863651013*^9}, {
  3.785140641246636*^9, 3.785140648679674*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"03def9c3-a9e8-4223-a884-a1bbdb6a1f0f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NonZeroCorrelations", "[", 
   RowBox[{"n_", ",", "f_"}], "]"}], ":=", 
  RowBox[{"Select", "[", 
   RowBox[{
    RowBox[{"Correlations", "[", 
     RowBox[{"n", ",", "f"}], "]"}], ",", 
    RowBox[{
     RowBox[{"Not", "[", 
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "==", "0"}], "]"}], "&"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7852541154441357`*^9, 3.7852541632850027`*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"70020611-85f6-4ecc-9a6a-1dc7c5d957e2"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example 4.8(0) majority vote (Lecture 6)", "Subsection",
 CellChangeTimes->{{3.720697739628528*^9, 3.720697741181705*^9}, {
  3.720698901070334*^9, 3.7206989042017736`*^9}, {3.782119960762281*^9, 
  3.782119962375461*^9}, {3.7821484276094217`*^9, 
  3.782148429461104*^9}},ExpressionUUID->"a95516c8-47be-482f-8acb-\
0a8e0e6ab165"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MajorityVote", "[", "xs_", "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Plus", "@@", "xs"}], "\[GreaterEqual]", 
     RowBox[{
      RowBox[{"Length", "[", "xs", "]"}], "/", "2"}]}], ",", "1", ",", "0"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.720697743590843*^9, 3.7206977723055153`*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"5eb956d6-a2de-4bb6-acac-f5756c80a9a0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"TruthTable", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"MajorityVote", ",", 
        RowBox[{"L", "[", "0", "]"}], ",", 
        RowBox[{"L", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}], "]"}], ",", 
        RowBox[{"L", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "2"}], "}"}], "]"}]}], "}"}]}], "]"}], "//",
     "TF"}], ",", 
   RowBox[{
    RowBox[{"Correlations", "[", 
     RowBox[{"3", ",", "MajorityVote"}], "]"}], "//", "TF"}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.720698774784664*^9, 3.720698832673644*^9}, {
  3.7821197622098007`*^9, 3.782119781131412*^9}, {3.78211990709328*^9, 
  3.782119913115089*^9}},
 CellLabel->"In[18]:=",ExpressionUUID->"d048e2b5-00dc-452f-ab91-301a89c9df7e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[GridBox[{
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Function[BoxForm`e$, 
     TableForm[BoxForm`e$, TableDepth -> 2]]], ",", 
   TagBox[GridBox[{
      {
       RowBox[{"{", "}"}], "0"},
      {
       RowBox[{"{", "0", "}"}], 
       FractionBox["1", "2"]},
      {
       RowBox[{"{", "1", "}"}], 
       FractionBox["1", "2"]},
      {
       RowBox[{"{", "2", "}"}], 
       FractionBox["1", "2"]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], "0"},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "2"}], "}"}], "0"},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], "0"},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "2"}], "}"}], 
       RowBox[{"-", 
        FractionBox["1", "2"]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Function[BoxForm`e$, 
     TableForm[BoxForm`e$, TableDepth -> 2]]]}], "}"}]], "Output",
 CellChangeTimes->{{3.7206987808396072`*^9, 3.72069883314819*^9}, 
   3.720875606423925*^9, 3.721053703237576*^9, 3.721747020496985*^9, 
   3.721747838221189*^9, 3.781511976545067*^9, 3.7821196815743923`*^9, {
   3.782119767149145*^9, 3.782119781384273*^9}, 3.782119815897829*^9, 
   3.782119868060465*^9, 3.782119913454329*^9, 3.782119954617182*^9, {
   3.78214851173883*^9, 3.782148528012038*^9}, 3.782722137929371*^9, 
   3.7831016638747787`*^9, 3.7851387061379023`*^9, 3.7851390060872602`*^9, 
   3.785140457992279*^9, 3.7851405958735113`*^9, 3.7852320455852833`*^9, 
   3.78525674963417*^9},
 CellLabel->"Out[18]=",ExpressionUUID->"eac2f6d3-eb53-483b-a84c-e0e390e161c7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NonZeroCorrelations", "[", 
  RowBox[{"3", ",", "MajorityVote"}], "]"}]], "Input",
 CellChangeTimes->{{3.785254145418087*^9, 3.785254150843617*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"d62a42ba-37a4-49c2-a8ed-0dc89fdf585b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "0", "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2"}], "}"}], ",", 
     RowBox[{"-", 
      FractionBox["1", "2"]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.78525415142165*^9, 3.7852541662250967`*^9}, 
   3.7852567497152452`*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"66e0db07-219c-4349-b2cf-b56a07d88ad0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Check on relation", "Subsubsection",
 CellChangeTimes->{{3.782148447285817*^9, 
  3.782148449235834*^9}},ExpressionUUID->"d6d426b7-f11c-407c-9649-\
f9959c3888cd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"TruthTable", "[", 
   RowBox[{"3", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "^", 
        RowBox[{"MajorityVote", "[", "#", "]"}]}], "&"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"1", "/", "2"}], "*", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "^", 
          RowBox[{
           RowBox[{"L", "[", 
            RowBox[{"{", "0", "}"}], "]"}], "[", "#", "]"}]}]}], "+", 
        RowBox[{
         RowBox[{"1", "/", "2"}], "*", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "^", 
          RowBox[{
           RowBox[{"L", "[", 
            RowBox[{"{", "1", "}"}], "]"}], "[", "#", "]"}]}]}], "+", 
        RowBox[{
         RowBox[{"1", "/", "2"}], "*", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "^", 
          RowBox[{
           RowBox[{"L", "[", 
            RowBox[{"{", "2", "}"}], "]"}], "[", "#", "]"}]}]}], "-", 
        RowBox[{
         RowBox[{"1", "/", "2"}], "*", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "^", 
          RowBox[{
           RowBox[{"L", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "2"}], "}"}], "]"}], "[", "#", 
           "]"}]}]}]}], "&"}]}], "}"}]}], "]"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.782148451189569*^9, 3.7821484593461647`*^9}, {
  3.78214853239755*^9, 3.78214865865746*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"8242e8d2-40e2-4996-b56a-44be2a171fa0"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.782148552886992*^9, 3.782148560485478*^9}, {
   3.7821486180066557`*^9, 3.78214865934718*^9}, 3.782722138054667*^9, 
   3.7831016639595947`*^9, 3.785138706233864*^9, 3.785139006187505*^9, 
   3.785140458100499*^9, 3.785140596483499*^9, 3.785232045691736*^9, 
   3.785256749802863*^9},
 CellLabel->
  "Out[20]//TableForm=",ExpressionUUID->"59a309df-9aa6-4235-92f2-\
9907578c26f2"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example 4.8(1) x0x1x2 (Lecture 8)", "Subsection",
 CellChangeTimes->{{3.782119965338478*^9, 3.7821199693752737`*^9}, {
   3.7821484317471237`*^9, 3.782148433346265*^9}, 
   3.782722152958126*^9},ExpressionUUID->"16e432a1-5051-480c-91a5-\
9aa6389df5b7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"x012", "[", "xs_", "]"}], ":=", 
  RowBox[{
   RowBox[{"xs", "[", 
    RowBox[{"[", "1", "]"}], "]"}], "*", 
   RowBox[{"xs", "[", 
    RowBox[{"[", "2", "]"}], "]"}], "*", 
   RowBox[{"xs", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.720698857739047*^9, 3.7206988868603373`*^9}, 
   3.782119764082828*^9, {3.782119973035667*^9, 3.782119984955873*^9}},
 CellLabel->"In[21]:=",ExpressionUUID->"c7aa219a-a20b-4b86-92f8-2f0330dbb248"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"TruthTable", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"x012", ",", 
        RowBox[{"L", "[", "0", "]"}], ",", 
        RowBox[{"L", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}], "]"}], ",", 
        RowBox[{"L", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "2"}], "}"}], "]"}]}], "}"}]}], "]"}], "//",
     "TF"}], ",", 
   RowBox[{
    RowBox[{"Correlations", "[", 
     RowBox[{"3", ",", "x012"}], "]"}], "//", "TF"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.78211999953084*^9, 3.782120003060288*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"43e8cdf9-0780-45f3-b173-800b15a4a1dc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[GridBox[{
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Function[BoxForm`e$, 
     TableForm[BoxForm`e$, TableDepth -> 2]]], ",", 
   TagBox[GridBox[{
      {
       RowBox[{"{", "}"}], 
       FractionBox["3", "4"]},
      {
       RowBox[{"{", "0", "}"}], 
       FractionBox["1", "4"]},
      {
       RowBox[{"{", "1", "}"}], 
       FractionBox["1", "4"]},
      {
       RowBox[{"{", "2", "}"}], 
       FractionBox["1", "4"]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], 
       RowBox[{"-", 
        FractionBox["1", "4"]}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "2"}], "}"}], 
       RowBox[{"-", 
        FractionBox["1", "4"]}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], 
       RowBox[{"-", 
        FractionBox["1", "4"]}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "2"}], "}"}], 
       FractionBox["1", "4"]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Function[BoxForm`e$, 
     TableForm[BoxForm`e$, TableDepth -> 2]]]}], "}"}]], "Output",
 CellChangeTimes->{3.782120004184679*^9, 3.782722138146235*^9, 
  3.783101664045878*^9, 3.785138706330084*^9, 3.785139006854014*^9, 
  3.785140460879125*^9, 3.7851405967768717`*^9, 3.785232045821302*^9, 
  3.785256754209988*^9},
 CellLabel->"Out[22]=",ExpressionUUID->"a22a6406-3074-4b7b-b200-241ae09811cd"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example 4.8 (3) x0x1 (Lecture 8)", "Subsection",
 CellChangeTimes->{{3.782722151094852*^9, 
  3.782722161101718*^9}},ExpressionUUID->"dc9c50bf-4e8a-4a91-9a67-\
a80b8ac96a8d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"x01", "[", "xs_", "]"}], ":=", 
  RowBox[{
   RowBox[{"xs", "[", 
    RowBox[{"[", "1", "]"}], "]"}], "*", 
   RowBox[{"xs", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.782722164674197*^9, 3.7827221708335342`*^9}},
 CellLabel->"In[23]:=",ExpressionUUID->"873e97ac-2c4d-4c1c-b5bb-8916bd4db7bb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"TruthTable", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"x01", ",", 
        RowBox[{"L", "[", 
         RowBox[{"{", "}"}], "]"}], ",", " ", 
        RowBox[{"L", "[", 
         RowBox[{"{", "0", "}"}], "]"}], ",", 
        RowBox[{"L", "[", 
         RowBox[{"{", "1", "}"}], "]"}], ",", 
        RowBox[{"L", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}], "]"}]}], "}"}]}], "]"}], "//", 
    "TF"}], ",", 
   RowBox[{
    RowBox[{"Correlations", "[", 
     RowBox[{"2", ",", "x01"}], "]"}], "//", "TF"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.7827221775096807`*^9, 3.78272220947123*^9}},
 CellLabel->"In[24]:=",ExpressionUUID->"fb8d3a61-9cc5-46b7-a4b9-927545aeed65"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[GridBox[{
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Function[BoxForm`e$, 
     TableForm[BoxForm`e$, TableDepth -> 2]]], ",", 
   TagBox[GridBox[{
      {
       RowBox[{"{", "}"}], 
       FractionBox["1", "2"]},
      {
       RowBox[{"{", "0", "}"}], 
       FractionBox["1", "2"]},
      {
       RowBox[{"{", "1", "}"}], 
       FractionBox["1", "2"]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], 
       RowBox[{"-", 
        FractionBox["1", "2"]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Function[BoxForm`e$, 
     TableForm[BoxForm`e$, TableDepth -> 2]]]}], "}"}]], "Output",
 CellChangeTimes->{3.782722210645382*^9, 3.783101664191745*^9, 
  3.785138706446938*^9, 3.785139007136839*^9, 3.7851404611123533`*^9, 
  3.78514059690409*^9, 3.785232046020646*^9, 3.785256754724201*^9},
 CellLabel->"Out[24]=",ExpressionUUID->"7115d687-4ee6-4fa2-a517-2b3b4aeb85d0"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example 4.8 (3) x0x1+x2x3 (Lecture 8)", "Subsection",
 CellChangeTimes->{{3.782120048750524*^9, 3.7821200547794247`*^9}, {
  3.7821484350085382`*^9, 3.782148437009988*^9}, {3.7827221476517687`*^9, 
  3.782722154795662*^9}},ExpressionUUID->"d2b758a7-4e90-4a2f-b779-\
af4faa118837"],

Cell[BoxData[
 RowBox[{"ClearAll", "[", "f", "]"}]], "Input",
 CellChangeTimes->{{3.7827271781455927`*^9, 3.782727179661262*^9}},
 CellLabel->"In[25]:=",ExpressionUUID->"926dc66f-d676-4e82-b7be-309728d1ec67"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"{", 
    RowBox[{"x0_", ",", "x1_", ",", "x2_", ",", "x3_"}], "}"}], "]"}], ":=", 
  RowBox[{"x0", "*", "x1", "*", "x2", "*", "x3"}]}]], "Input",
 CellChangeTimes->{{3.7827271554517307`*^9, 3.782727309104388*^9}},
 CellLabel->"In[26]:=",ExpressionUUID->"558a5615-f583-42f7-b2fa-a15567e767cc"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.782727239445836*^9, 3.782727240399816*^9}},
 CellLabel->"In[27]:=",ExpressionUUID->"e3ce6dea-3c91-454a-8562-4d7554ef3494"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Correlations", "[", 
    RowBox[{"4", ",", "f"}], "]"}], "//", "Transpose"}], "//", 
  "TF"}]], "Input",
 CellChangeTimes->{{3.782727182237441*^9, 3.782727192651931*^9}},
 CellLabel->"In[28]:=",ExpressionUUID->"319a27a0-d144-4c09-a142-454d006e3802"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", "}"}], 
     RowBox[{"{", "0", "}"}], 
     RowBox[{"{", "1", "}"}], 
     RowBox[{"{", "2", "}"}], 
     RowBox[{"{", "3", "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}]},
    {
     FractionBox["7", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     RowBox[{"-", 
      FractionBox["1", "8"]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.7827271946569147`*^9, 3.7827272107819023`*^9}, 
   3.782727242948291*^9, {3.7827272852578287`*^9, 3.78272732489478*^9}, 
   3.7831016643234653`*^9, 3.7851387065676737`*^9, 3.785139007273143*^9, 
   3.785140461351288*^9, 3.785140599726918*^9, 3.785232046148376*^9, 
   3.785256755075729*^9},
 CellLabel->
  "Out[28]//TableForm=",ExpressionUUID->"07c8c301-87ba-4889-b049-\
57638bee105a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Bent", "[", "xs_", "]"}], ":=", 
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"xs", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "*", 
      RowBox[{"xs", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"xs", "[", 
       RowBox[{"[", "3", "]"}], "]"}], "*", 
      RowBox[{"xs", "[", 
       RowBox[{"[", "4", "]"}], "]"}]}]}], ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.782120055668396*^9, 3.782120069274208*^9}},
 CellLabel->"In[29]:=",ExpressionUUID->"6332ae9d-49dc-42da-9ee1-bb78adec2257"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"TruthTable", "[", 
     RowBox[{"4", ",", 
      RowBox[{"{", 
       RowBox[{"Bent", ",", 
        RowBox[{"L", "[", "0", "]"}], ",", 
        RowBox[{"L", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}], "]"}], ",", 
        RowBox[{"L", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "2"}], "}"}], "]"}]}], "}"}]}], "]"}], "//",
     "TF"}], ",", 
   RowBox[{
    RowBox[{"Correlations", "[", 
     RowBox[{"4", ",", "Bent"}], "]"}], "//", "TF"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.782120074952533*^9, 3.782120084374819*^9}},
 CellLabel->"In[30]:=",ExpressionUUID->"93a5bba6-a0a7-4cab-9547-18fcbbb19020"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[GridBox[{
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Function[BoxForm`e$, 
     TableForm[BoxForm`e$, TableDepth -> 2]]], ",", 
   TagBox[GridBox[{
      {
       RowBox[{"{", "}"}], 
       FractionBox["1", "4"]},
      {
       RowBox[{"{", "0", "}"}], 
       FractionBox["1", "4"]},
      {
       RowBox[{"{", "1", "}"}], 
       FractionBox["1", "4"]},
      {
       RowBox[{"{", "2", "}"}], 
       FractionBox["1", "4"]},
      {
       RowBox[{"{", "3", "}"}], 
       FractionBox["1", "4"]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], 
       RowBox[{"-", 
        FractionBox["1", "4"]}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "2"}], "}"}], 
       FractionBox["1", "4"]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "3"}], "}"}], 
       FractionBox["1", "4"]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], 
       FractionBox["1", "4"]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "3"}], "}"}], 
       FractionBox["1", "4"]},
      {
       RowBox[{"{", 
        RowBox[{"2", ",", "3"}], "}"}], 
       RowBox[{"-", 
        FractionBox["1", "4"]}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "2"}], "}"}], 
       RowBox[{"-", 
        FractionBox["1", "4"]}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "3"}], "}"}], 
       RowBox[{"-", 
        FractionBox["1", "4"]}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "2", ",", "3"}], "}"}], 
       RowBox[{"-", 
        FractionBox["1", "4"]}]},
      {
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "3"}], "}"}], 
       RowBox[{"-", 
        FractionBox["1", "4"]}]},
      {
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], 
       FractionBox["1", "4"]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Function[BoxForm`e$, 
     TableForm[BoxForm`e$, TableDepth -> 2]]]}], "}"}]], "Output",
 CellChangeTimes->{3.782727069055677*^9, 3.7831016644232063`*^9, 
  3.7851387066790323`*^9, 3.7851390074024897`*^9, 3.785140461480317*^9, 
  3.785140599860404*^9, 3.785232046256626*^9, 3.785256755642425*^9},
 CellLabel->"Out[30]=",ExpressionUUID->"c515bd84-d37d-4328-a28b-c361399afc5f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Bent6", "[", "xs_", "]"}], ":=", 
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"xs", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "*", 
      RowBox[{"xs", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"xs", "[", 
       RowBox[{"[", "3", "]"}], "]"}], "*", 
      RowBox[{"xs", "[", 
       RowBox[{"[", "4", "]"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"xs", "[", 
       RowBox[{"[", "5", "]"}], "]"}], "*", 
      RowBox[{"xs", "[", 
       RowBox[{"[", "6", "]"}], "]"}]}]}], ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7827246955016193`*^9, 3.782724702123869*^9}, {
  3.782724772795931*^9, 3.782724776598097*^9}},
 CellLabel->"In[31]:=",ExpressionUUID->"df7ab3cb-43e6-41dd-b1d4-b0bd0c592701"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Correlations", "[", 
    RowBox[{"6", ",", "Bent6"}], "]"}], "//", "Transpose"}], "//", 
  "TF"}]], "Input",
 CellChangeTimes->{{3.782724708964511*^9, 3.782724715765121*^9}, 
   3.7827247521247253`*^9, {3.782724854365438*^9, 3.782724869340426*^9}},
 CellLabel->"In[32]:=",ExpressionUUID->"c0e03015-39b9-4556-a2f6-c0d2fb1a03e8"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", "}"}], 
     RowBox[{"{", "0", "}"}], 
     RowBox[{"{", "1", "}"}], 
     RowBox[{"{", "2", "}"}], 
     RowBox[{"{", "3", "}"}], 
     RowBox[{"{", "4", "}"}], 
     RowBox[{"{", "5", "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "3", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "3", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2", ",", "3", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "3", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2", ",", "3", ",", "4", ",", "5"}], 
      "}"}]},
    {
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     FractionBox["1", "8"], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     FractionBox["1", "8"], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     RowBox[{"-", 
      FractionBox["1", "8"]}], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     FractionBox["1", "8"], 
     RowBox[{"-", 
      FractionBox["1", "8"]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.7827248639629507`*^9, 3.7827248705970173`*^9}, 
   3.783101664578637*^9, 3.7851387068400507`*^9, 3.785139010322345*^9, 
   3.7851404616955223`*^9, 3.785140600094122*^9, 3.785232046438757*^9, 
   3.7852567562425528`*^9},
 CellLabel->
  "Out[32]//TableForm=",ExpressionUUID->"78361615-df4f-46f7-aea9-\
2c10454113e1"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Question 6 on Problem Sheet 5", "Subsection",
 CellChangeTimes->{{3.783101709462554*^9, 
  3.7831017142192917`*^9}},ExpressionUUID->"62e2ca63-c74f-433c-999b-\
5e552a2677c6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"{", 
    RowBox[{"x0_", ",", "x1_", ",", "x2_"}], "}"}], "]"}], ":=", 
  RowBox[{"x1", "*", "x2"}]}]], "Input",
 CellChangeTimes->{{3.783101715730751*^9, 3.783101730482419*^9}},
 CellLabel->"In[33]:=",ExpressionUUID->"8653b510-5f51-46ce-b1bb-60a52ab6f56b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Correlations", "[", "f", "]"}]], "Input",
 CellChangeTimes->{{3.783101731285591*^9, 3.783101733830182*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"54571196-ecc0-46b3-9b6d-e42edfa95d6d"],

Cell[BoxData[
 RowBox[{"Correlations", "[", "f", "]"}]], "Output",
 CellChangeTimes->{3.78513870703586*^9, 3.7851390104768457`*^9, 
  3.7851404618164454`*^9, 3.785140600261462*^9, 3.7852320465563107`*^9, 
  3.785256756676738*^9},
 CellLabel->"Out[34]=",ExpressionUUID->"f797064b-e172-4d21-997a-3e52d23c23f5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Correlations", "[", 
  RowBox[{"3", ",", "f"}], "]"}]], "Input",
 CellChangeTimes->{{3.7831017398789177`*^9, 3.783101739984612*^9}, {
  3.7831018216104393`*^9, 3.783101821677322*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"7c78a3af-8035-485f-80ca-af851768151b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "0", "}"}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "2"}], "}"}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"-", 
      FractionBox["1", "2"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2"}], "}"}], ",", "0"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.783101740530314*^9, 3.783101822008698*^9, 
  3.7851387071197443`*^9, 3.785139010597928*^9, 3.7851404619186983`*^9, 
  3.7851406003782673`*^9, 3.785232046633954*^9, 3.785256756901902*^9},
 CellLabel->"Out[35]=",ExpressionUUID->"4b0a90c7-5d58-4991-afab-3a7452cd4333"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"g", "[", 
   RowBox[{"{", 
    RowBox[{"x0_", ",", "x1_", ",", "x2_"}], "}"}], "]"}], ":=", 
  RowBox[{"x0", "+", 
   RowBox[{"x1", "*", "x2"}]}]}]], "Input",
 CellChangeTimes->{{3.78310292697744*^9, 3.783102928435894*^9}},
 CellLabel->"In[36]:=",ExpressionUUID->"417a12dc-9e02-44c0-baac-74367c9f2243"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Correlations", "[", 
  RowBox[{"3", ",", "g"}], "]"}]], "Input",
 CellChangeTimes->{{3.783102922013502*^9, 3.783102930650775*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"9a5a20ee-5019-4bf7-9dc1-9345009384ce"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "0", "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "2"}], "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2"}], "}"}], ",", 
     RowBox[{"-", 
      FractionBox["1", "2"]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.783102930918489*^9, 3.7851387072284737`*^9, 
  3.785139010744136*^9, 3.785140462649584*^9, 3.785140600546213*^9, 
  3.785232046754656*^9, 3.785256757276931*^9},
 CellLabel->"Out[37]=",ExpressionUUID->"c01ea11d-3851-4d68-8bd6-11e1ce0c9ecc"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Correlation Matrix (final M.Sc. lecture 2019)", "Section",
 CellChangeTimes->{{3.7851387183858423`*^9, 3.785138720386747*^9}, {
  3.7851502859207373`*^9, 
  3.785150292200288*^9}},ExpressionUUID->"8c2631f2-bf59-442c-9dc8-\
8401af448338"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelationsLex", "[", 
   RowBox[{"n_", ",", "f_"}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"T", ",", 
      RowBox[{"Corr", "[", 
       RowBox[{"n", ",", "f", ",", 
        RowBox[{"L", "[", "T", "]"}]}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"T", ",", 
      RowBox[{"SubsetsLex", "[", 
       RowBox[{"Range", "[", 
        RowBox[{"0", ",", 
         RowBox[{"n", "-", "1"}]}], "]"}], "]"}]}], "}"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.7851406541474047`*^9, 3.78514065637854*^9}},
 CellLabel->"In[38]:=",ExpressionUUID->"a1eca3f7-df40-4d7a-806e-611aabef109f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"L", "[", 
   RowBox[{"T_", ",", "F_"}], "]"}], ":=", 
  RowBox[{"Function", "[", 
   RowBox[{"x", ",", 
    RowBox[{
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"F", "[", "x", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"t", "+", "1"}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "T"}], "}"}]}], "]"}], "//", "Mod2"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7851393098210497`*^9, 3.785139338002459*^9}},
 CellLabel->"In[39]:=",ExpressionUUID->"0bc97073-8470-486a-85d0-3bb038bc3467"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelationMatrixFull", "[", 
   RowBox[{"n_", ",", "F_"}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"T", ",", 
      RowBox[{"CorrelationsLex", "[", 
       RowBox[{"n", ",", 
        RowBox[{"L", "[", 
         RowBox[{"T", ",", "F"}], "]"}]}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"T", ",", 
      RowBox[{"SubsetsLex", "[", 
       RowBox[{"Range", "[", 
        RowBox[{"0", ",", 
         RowBox[{"n", "-", "1"}]}], "]"}], "]"}]}], "}"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.785138727027836*^9, 3.785138805534937*^9}, {
  3.7851389213183002`*^9, 3.7851389221052427`*^9}, {3.785138959133526*^9, 
  3.785138962191036*^9}, {3.785139377446007*^9, 3.78513938740981*^9}, {
  3.7851396030591917`*^9, 3.785139603518216*^9}, {3.785140468315465*^9, 
  3.785140468628105*^9}, {3.7851406690277853`*^9, 3.785140669340536*^9}},
 CellLabel->"In[40]:=",ExpressionUUID->"0ea16a39-3f2f-4f75-87d3-b614c6b5c635"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelationMatrix", "[", 
   RowBox[{"n_", ",", "F_"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
      RowBox[{"#", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], "&"}], ",", 
    RowBox[{"CorrelationMatrixFull", "[", 
     RowBox[{"n", ",", "F"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7851396042742567`*^9, 3.785139650016017*^9}},
 CellLabel->"In[41]:=",ExpressionUUID->"9640ed0a-d6e6-4813-bb80-60ecc8c05507"],

Cell[CellGroupData[{

Cell["Example 6.6 with n=2", "Subsection",
 CellChangeTimes->{{3.785138809673191*^9, 3.785138813213295*^9}, {
  3.785143642617093*^9, 
  3.785143643113896*^9}},ExpressionUUID->"ed1bd9d3-b2c7-4b73-abcd-\
a7d8857fd977"],

Cell[BoxData[
 RowBox[{
  RowBox[{"G2", "[", 
   RowBox[{"{", 
    RowBox[{"x0_", ",", "x1_"}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"x0", ",", 
    RowBox[{"x0", "*", "x1"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.785139717943791*^9, 3.7851397206324472`*^9}, {
  3.785141756695507*^9, 3.785141756910549*^9}},
 CellLabel->"In[42]:=",ExpressionUUID->"831313e6-50da-4325-adb5-efcb05ecb795"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelationMatrix", "[", 
   RowBox[{"2", ",", "G2"}], "]"}], "//", "MF"}]], "Input",
 CellChangeTimes->{{3.785138927208536*^9, 3.785138935607374*^9}, {
  3.785139092960772*^9, 3.785139093423772*^9}, {3.7851391788852367`*^9, 
  3.785139179381271*^9}, {3.785139590562599*^9, 3.785139591691328*^9}, {
  3.785139723291799*^9, 3.7851397250457087`*^9}, {3.785140155010792*^9, 
  3.785140155438981*^9}, {3.7852531767019043`*^9, 3.785253177349272*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"82fba150-d0a4-48d0-bfdc-c4af1bb7d8d3"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"], 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}]},
     {
      FractionBox["1", "2"], 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.785146519200809*^9, 3.78523204795579*^9, 
  3.785253177755007*^9, 3.785256757544545*^9},
 CellLabel->
  "Out[43]//MatrixForm=",ExpressionUUID->"8c5dcc3e-f961-4979-bf16-\
ed804aba9dd5"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"H2", "[", 
   RowBox[{"{", 
    RowBox[{"x0_", ",", "x1_"}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x0", "+", "1"}], ",", 
    RowBox[{
     RowBox[{"x0", "*", "x1"}], "+", "x1"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.785138813787902*^9, 3.785138850701659*^9}, {
  3.785138888315792*^9, 3.7851388895174026`*^9}, {3.785139242593954*^9, 
  3.78513924289802*^9}, {3.785139712410775*^9, 3.7851397167456617`*^9}, {
  3.785139823973751*^9, 3.7851398259955063`*^9}, {3.785141738364793*^9, 
  3.785141741453061*^9}},
 CellLabel->"In[44]:=",ExpressionUUID->"c23e937d-0478-4202-8cd3-2519975258c1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelationMatrix", "[", 
   RowBox[{"2", ",", "H2"}], "]"}], "//", "MF"}]], "Input",
 CellChangeTimes->{{3.7851397400073767`*^9, 3.785139740464652*^9}, {
  3.7851401578266373`*^9, 3.7851401582194633`*^9}, {3.7851417496598988`*^9, 
  3.785141750763544*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"36a4e087-c2e0-4d59-91eb-9c3f390f9583"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", 
      RowBox[{"-", "1"}], "0", "0"},
     {
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      FractionBox["1", "2"], 
      FractionBox["1", "2"]},
     {
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      RowBox[{"-", 
       FractionBox["1", "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.785146534274886*^9, 3.785232048131425*^9, 
  3.7852567579920073`*^9},
 CellLabel->
  "Out[45]//MatrixForm=",ExpressionUUID->"dab147a0-5767-492f-a521-\
249c4a737428"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"FFlip0", "[", 
   RowBox[{"{", 
    RowBox[{"x0_", ",", "x1_"}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x0", "+", "1"}], ",", "x1"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.785139858959708*^9, 3.785139875756185*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"87b2433d-3a62-457e-9e7b-a7e852719880"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelationMatrix", "[", 
   RowBox[{"2", ",", "FFlip0"}], "]"}], "//", "MF"}]], "Input",
 CellChangeTimes->{{3.7851398777191973`*^9, 3.785139888745816*^9}, {
  3.7851401420794153`*^9, 3.7851401423185596`*^9}},
 CellLabel->"In[47]:=",ExpressionUUID->"0f101de3-98b1-422d-92e2-3cfea3872882"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", 
      RowBox[{"-", "1"}], "0", "0"},
     {"0", "0", "1", "0"},
     {"0", "0", "0", 
      RowBox[{"-", "1"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.7851465397509813`*^9, 3.785232048241247*^9, 
  3.785256758124961*^9},
 CellLabel->
  "Out[47]//MatrixForm=",ExpressionUUID->"9584da2e-c58f-49d1-812f-\
47831c0c9b8e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Check on Proposition 6.5", "Subsection",
 CellChangeTimes->{{3.785139935680564*^9, 3.7851399385823383`*^9}, {
  3.785140102535173*^9, 
  3.78514010271154*^9}},ExpressionUUID->"1af19bbe-0bfa-4eef-ab0d-\
d950d40625c3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"CorrelationMatrix", "[", 
     RowBox[{"2", ",", "H2"}], "]"}], "//", "MF"}], ",", 
   RowBox[{
    RowBox[{"CorrelationMatrix", "[", 
     RowBox[{"2", ",", "G2"}], "]"}], "//", "MF"}], ",", 
   RowBox[{
    RowBox[{"CorrelationMatrix", "[", 
     RowBox[{"2", ",", "FFlip0"}], "]"}], "//", "MF"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"CorrelationMatrix", "[", 
      RowBox[{"2", ",", "G2"}], "]"}], ".", 
     RowBox[{"CorrelationMatrix", "[", 
      RowBox[{"2", ",", "FFlip0"}], "]"}]}], "//", "MF"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.785140103621304*^9, 3.785140140069524*^9}, {
  3.785141776158231*^9, 3.7851417999410963`*^9}},
 CellLabel->"In[48]:=",ExpressionUUID->"f559afa6-a697-4aca-9e7d-b753ef8504d0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0", "0", "0"},
       {"0", 
        RowBox[{"-", "1"}], "0", "0"},
       {
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "2"]},
       {
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        RowBox[{"-", 
         FractionBox["1", "2"]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0", "0", "0"},
       {"0", "1", "0", "0"},
       {
        FractionBox["1", "2"], 
        FractionBox["1", "2"], 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "2"]}]},
       {
        FractionBox["1", "2"], 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        FractionBox["1", "2"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0", "0", "0"},
       {"0", 
        RowBox[{"-", "1"}], "0", "0"},
       {"0", "0", "1", "0"},
       {"0", "0", "0", 
        RowBox[{"-", "1"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0", "0", "0"},
       {"0", 
        RowBox[{"-", "1"}], "0", "0"},
       {
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "2"]},
       {
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        RowBox[{"-", 
         FractionBox["1", "2"]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 CellChangeTimes->{3.785146549693282*^9, 3.7852320483385468`*^9, 
  3.7852567582250423`*^9},
 CellLabel->"Out[48]=",ExpressionUUID->"e4288f26-ca77-4faa-8245-5e6a1acbd049"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example for final M.Sc. lecture", "Subsection",
 CellChangeTimes->{{3.7851395775449743`*^9, 
  3.785139582844739*^9}},ExpressionUUID->"c7e28223-1ad8-45e1-af55-\
08ec44affc8d"],

Cell[BoxData[
 RowBox[{"ClearAll", "[", "S4", "]"}]], "Input",
 CellChangeTimes->{{3.7851418511035547`*^9, 3.785141853178014*^9}},
 CellLabel->"In[49]:=",ExpressionUUID->"751b545a-6e98-4faa-8514-fb0adaa28fab"],

Cell[BoxData[
 RowBox[{
  RowBox[{"S4", "[", 
   RowBox[{"{", 
    RowBox[{"x0_", ",", "x1_", ",", "x2_", ",", "x3_"}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"x2", ",", "x3", ",", 
    RowBox[{"x0", "+", 
     RowBox[{"x1", "*", "x2"}]}], ",", 
    RowBox[{"x1", "+", 
     RowBox[{"x2", "*", "x3"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.7851395547797813`*^9, 3.785139571077181*^9}, {
  3.785140735838727*^9, 3.7851407764260187`*^9}, {3.785141830239498*^9, 
  3.785141877565846*^9}},
 CellLabel->"In[50]:=",ExpressionUUID->"a28829cf-6894-495d-9d25-34485aee96d2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SubsetsLex", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.78514017974111*^9, 3.7851401898748207`*^9}, {
   3.785140487311983*^9, 3.7851404876191053`*^9}, 3.785140561591177*^9, {
   3.7851418646157703`*^9, 3.785141864718657*^9}},
 CellLabel->"In[51]:=",ExpressionUUID->"ab49c265-4003-40cb-9692-12a82395dd52"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "0", "}"}], ",", 
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "2", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "3", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.785140182848503*^9, 3.7851401901460533`*^9}, {
   3.785140464713006*^9, 3.785140488137796*^9}, {3.7851405600407877`*^9, 
   3.7851405620812817`*^9}, 3.785140601525021*^9, 3.785140754877944*^9, {
   3.785141865035231*^9, 3.7851418785202827`*^9}, 3.785146621862677*^9, 
   3.785232048471567*^9, 3.785256758357629*^9},
 CellLabel->"Out[51]=",ExpressionUUID->"71e11971-4293-4118-bfa3-e399739ba34c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelationMatrix", "[", 
   RowBox[{"4", ",", "S4"}], "]"}], "//", "MF"}]], "Input",
 CellChangeTimes->{
  3.785139198891306*^9, {3.785139261731702*^9, 3.785139263627926*^9}, {
   3.78513958703085*^9, 3.785139597074951*^9}, {3.7851408663389606`*^9, 
   3.7851408668061247`*^9}, {3.785141867787384*^9, 3.785141868742406*^9}},
 CellLabel->"In[52]:=",ExpressionUUID->"5a0f4215-bffd-47db-89e2-a065be192860"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", 
      "0", "0"},
     {"0", 
      FractionBox["1", "2"], "0", 
      FractionBox["1", "2"], "0", 
      FractionBox["1", "2"], "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", 
      FractionBox["1", "2"], "0", 
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], "0", 
      FractionBox["1", "2"], "0", 
      FractionBox["1", "2"], "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}]},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", 
      FractionBox["1", "2"], "0", 
      FractionBox["1", "2"]},
     {"0", "0", 
      FractionBox["1", "2"], "0", "0", "0", 
      FractionBox["1", "2"], "0", "0", "0", 
      FractionBox["1", "2"], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0"},
     {"0", "0", 
      FractionBox["1", "2"], "0", "0", "0", 
      FractionBox["1", "2"], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", 
      FractionBox["1", "2"], "0"},
     {"0", "0", 
      FractionBox["1", "2"], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", 
      FractionBox["1", "2"], "0", "0", "0", 
      FractionBox["1", "2"], "0"},
     {"0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", 
      FractionBox["1", "2"], "0", "0", "0", 
      FractionBox["1", "2"], "0", "0", "0", 
      FractionBox["1", "2"], "0"},
     {"0", "0", "0", 
      FractionBox["1", "2"], "0", "0", "0", 
      FractionBox["1", "2"], "0", 
      FractionBox["1", "2"], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0"},
     {"0", "0", "0", 
      FractionBox["1", "2"], "0", "0", "0", 
      FractionBox["1", "2"], "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", 
      FractionBox["1", "2"], "0", "0"},
     {"0", 
      FractionBox["1", "2"], "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], "0", "0", "0", 
      FractionBox["1", "2"]},
     {"0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", 
      FractionBox["1", "2"], "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], "0", "0", "0", 
      FractionBox["1", "2"]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.785146649729541*^9, 3.785232048606637*^9, 
  3.785256758511291*^9},
 CellLabel->
  "Out[52]//MatrixForm=",ExpressionUUID->"68308119-9880-4ef3-b293-\
574340073383"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"S4twice", "[", "xs_", "]"}], ":=", 
  RowBox[{
   RowBox[{"S4", "[", 
    RowBox[{"S4", "[", "xs", "]"}], "]"}], "//", "ModTwo"}]}]], "Input",
 CellChangeTimes->{{3.785140804005797*^9, 3.7851408237445507`*^9}, {
  3.7851418910147457`*^9, 3.7851418941681023`*^9}},
 CellLabel->"In[53]:=",ExpressionUUID->"eba61130-1faa-48d7-85a5-c08b933a50dd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"S4twice", "[", 
  RowBox[{"{", 
   RowBox[{"x0", ",", "x1", ",", "x2", ",", "x3"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.785140813641222*^9, 3.7851408185300007`*^9}, {
  3.7851418967064466`*^9, 3.78514189851546*^9}},
 CellLabel->"In[54]:=",ExpressionUUID->"b738befd-f788-438a-8379-90d7aabb2f7c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"x0", "+", 
      RowBox[{"x1", " ", "x2"}]}], ",", "2"}], "]"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"x1", "+", 
      RowBox[{"x2", " ", "x3"}]}], ",", "2"}], "]"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"x2", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x0", "+", 
         RowBox[{"x1", " ", "x2"}]}], ")"}], " ", "x3"}]}], ",", "2"}], "]"}],
    ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"x3", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x0", "+", 
         RowBox[{"x1", " ", "x2"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"x1", "+", 
         RowBox[{"x2", " ", "x3"}]}], ")"}]}]}], ",", "2"}], "]"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.78514081888818*^9, 3.785140849067787*^9}, 
   3.785141899068117*^9, 3.78514670948181*^9, 3.785232048723068*^9, 
   3.78525675862346*^9},
 CellLabel->"Out[54]=",ExpressionUUID->"9867b921-f2f7-470d-ba9a-3781320d7d62"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"MatrixPower", "[", 
     RowBox[{
      RowBox[{"CorrelationMatrix", "[", 
       RowBox[{"4", ",", "S4"}], "]"}], ",", "2"}], "]"}], "//", "MF"}], ",", 
   
   RowBox[{
    RowBox[{"CorrelationMatrix", "[", 
     RowBox[{"4", ",", "S4twice"}], "]"}], "//", "MF"}], ",", 
   RowBox[{
    RowBox[{"MatrixPower", "[", 
     RowBox[{
      RowBox[{"CorrelationMatrix", "[", 
       RowBox[{"4", ",", "S4"}], "]"}], ",", "2"}], "]"}], "==", 
    RowBox[{"CorrelationMatrix", "[", 
     RowBox[{"4", ",", "S4twice"}], "]"}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.785140856276863*^9, 3.7851408896968403`*^9}, {
  3.785141902897532*^9, 3.7851419065107937`*^9}, {3.785141990005666*^9, 
  3.785141999006474*^9}},
 CellLabel->"In[55]:=",ExpressionUUID->"d4e05873-8297-4815-9f78-c8c6636e51ee"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"], "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0"},
       {"0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", "0"},
       {"0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}]},
       {"0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"]},
       {"0", 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}]},
       {"0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"]},
       {"0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "2"]}]},
       {"0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0"},
       {"0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], 
        FractionBox["1", "2"]},
       {"0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0"},
       {"0", "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"]},
       {"0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"]},
       {"0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"]},
       {"0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"], "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0"},
       {"0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", "0"},
       {"0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}]},
       {"0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"]},
       {"0", 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}]},
       {"0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"]},
       {"0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "2"]}]},
       {"0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0"},
       {"0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], 
        FractionBox["1", "2"]},
       {"0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0"},
       {"0", "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"]},
       {"0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"]},
       {"0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"]},
       {"0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", "True"}], "}"}]], "Output",
 CellChangeTimes->{3.78514673607211*^9, 3.785232049190208*^9, 
  3.785256759476255*^9},
 CellLabel->"Out[55]=",ExpressionUUID->"2e0af690-c799-4bbc-ba06-33a8e2e170ec"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"c4", "=", 
   RowBox[{"CorrelationMatrix", "[", 
    RowBox[{"4", ",", "S4"}], "]"}]}], ";", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"MatrixPower", "[", 
      RowBox[{"c4", ",", "r"}], "]"}], "//", "MF"}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", "0", ",", "2"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.785140903849378*^9, 3.785140952232176*^9}, {
  3.785142004192664*^9, 3.7851420200824823`*^9}, {3.785142113076058*^9, 
  3.785142113307399*^9}, {3.785146793588142*^9, 3.785146793993847*^9}, {
  3.785150325104785*^9, 3.785150325279819*^9}},
 CellLabel->"In[56]:=",ExpressionUUID->"cb80f305-11ba-4f81-b6a4-ebadfc71cb26"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", 
        "0", "0"},
       {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", 
        "0", "0"},
       {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "1", "0"},
       {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "1"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", 
        "0", "0"},
       {"0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"], "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", "0", "0", "0", "0", "0", "0", "0"},
       {"0", 
        FractionBox["1", "2"], "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "0", "0", "0", "0", "0", "0", "0", "0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"], "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}]},
       {"0", "0", "0", "0", "0", "0", "0", "0", "0", 
        FractionBox["1", "2"], "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"]},
       {"0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0"},
       {"0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", "0", "0", 
        FractionBox["1", "2"], "0"},
       {"0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0"},
       {"0", "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0"},
       {"0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", "0"},
       {"0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", "0", "0", 
        FractionBox["1", "2"], "0", "0"},
       {"0", 
        FractionBox["1", "2"], "0", "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", "0", "0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"]},
       {"0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"], "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0"},
       {"0", "0", "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "2"], "0", "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], "0", "0"},
       {"0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}]},
       {"0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"]},
       {"0", 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}]},
       {"0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "4"]},
       {"0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "2"]}]},
       {"0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], "0", 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0"},
       {"0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], 
        FractionBox["1", "2"]},
       {"0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0"},
       {"0", "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"]},
       {"0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], "0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "2"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"]},
       {"0", 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        FractionBox["1", "4"], 
        FractionBox["1", "2"], "0", 
        FractionBox["1", "4"], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], "0", "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"]},
       {"0", "0", 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "4"]}], 
        RowBox[{"-", 
         FractionBox["1", "2"]}], 
        FractionBox["1", "2"], 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"], "0", "0", 
        FractionBox["1", "4"], 
        FractionBox["1", "4"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 CellChangeTimes->{{3.785146775652699*^9, 3.785146795363515*^9}, 
   3.785150325713317*^9, 3.785232049431966*^9, 3.785256759806798*^9},
 CellLabel->"Out[56]=",ExpressionUUID->"8e2a8d25-1b15-45f9-b365-2335f95b526c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Since the 18th power of the correlation matrix is the identity, the S-box has \
order 18.\
\>", "Subsection",
 CellChangeTimes->{{3.785150333137844*^9, 
  3.7851503498065357`*^9}},ExpressionUUID->"86d6cb13-b837-46a6-b8f0-\
97df2d28a484"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MatrixPower", "[", 
   RowBox[{"c4", ",", "18"}], "]"}], "//", "MF"}]], "Input",
 CellChangeTimes->{{3.785142120261251*^9, 3.7851421300594463`*^9}},
 CellLabel->"In[57]:=",ExpressionUUID->"ba61c24b-5cd7-4728-85d9-f48fd5072b6d"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "1", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.785146839273424*^9, 3.785232049539727*^9, 
  3.7852567599974537`*^9},
 CellLabel->
  "Out[57]//MatrixForm=",ExpressionUUID->"1e88555f-6efe-4f9b-ba78-\
ba90fdf82d6b"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Full Q-block cipher", "Section",
 CellChangeTimes->{{3.785232059903718*^9, 3.7852320640189953`*^9}, {
   3.785232094403865*^9, 3.7852321370262403`*^9}, 
   3.7852321781290197`*^9},ExpressionUUID->"f8d1de75-1299-4872-a0e5-\
a6513c7634c1"],

Cell["\<\
By Lemma 6.4, a high correlation for the zero key is the same (or sign \
flipped) for an arbitrary key.\
\>", "Subsubsection",
 CellChangeTimes->{{3.7852321410424557`*^9, 
  3.785232176130786*^9}},ExpressionUUID->"9a1f1316-0c3b-4bcf-b156-\
4a38cf95afdc"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Q-Block Cipher (Example 9.5)", "Section",
 CellChangeTimes->{{3.752396426787991*^9, 3.752396442632187*^9}, {
  3.78317643078174*^9, 
  3.783176440269047*^9}},ExpressionUUID->"21815a01-0083-4715-9b67-\
b816d593b40e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SplitKey", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", "_"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}]], "Input",
 CellChangeTimes->{{3.752397545964189*^9, 3.752397550032895*^9}},
 CellLabel->"In[58]:=",ExpressionUUID->"713928f0-0a79-45f1-bc3f-6add4cccdbd0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SplitKey", "[", 
   RowBox[{"k_", ",", "m_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"k", "[", 
     RowBox[{"[", 
      RowBox[{"1", ";;", "m"}], "]"}], "]"}], "}"}], "~", "Join", "~", 
   RowBox[{"SplitKey", "[", 
    RowBox[{
     RowBox[{"Drop", "[", 
      RowBox[{"k", ",", "m"}], "]"}], ",", "m"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.752397527638852*^9, 3.752397557863632*^9}, {
  3.752397620756323*^9, 3.7523976219595947`*^9}},
 CellLabel->"In[59]:=",ExpressionUUID->"e2a1257d-07b9-4f8f-957d-f6cbdedb1ec4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PModTwo", "[", "xs_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"PolynomialMod", "[", 
     RowBox[{"#", ",", "2"}], "]"}], "&"}], "/@", "xs"}]}]], "Input",
 CellChangeTimes->{{3.785253558329911*^9, 3.785253561755351*^9}},
 CellLabel->"In[60]:=",ExpressionUUID->"2a6917be-7da0-4ebd-9d51-bcb28c618ad4"],

Cell[CellGroupData[{

Cell["Deliberately not reducing modulo 2 here or in SQ", "Subsubsection",
 CellChangeTimes->{{3.785253479234599*^9, 
  3.785253484804586*^9}},ExpressionUUID->"3b8d0733-d057-479b-8e28-\
ee019a218146"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FeistelRound", "[", 
   RowBox[{"S_", ",", "kRound_", ",", 
    RowBox[{"{", 
     RowBox[{"v_", ",", "w_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"w", ",", 
    RowBox[{"v", "+", 
     RowBox[{"S", "[", 
      RowBox[{"w", "+", "kRound"}], "]"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.752396517129778*^9, 3.752396528465803*^9}, {
   3.7852528772756844`*^9, 3.7852528931452303`*^9}, 3.785253475264032*^9},
 CellLabel->"In[61]:=",ExpressionUUID->"12338bb6-99ec-41b8-9a12-64ff6820334b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Feistel", "[", 
   RowBox[{"_", ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"v_", ",", "w_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"v", ",", "w"}], "}"}]}]], "Input",
 CellLabel->"In[62]:=",ExpressionUUID->"ecd468ec-f7af-4653-b0b9-f459f8ce0534"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Feistel", "[", 
   RowBox[{"S_", ",", "kRounds_", ",", 
    RowBox[{"{", 
     RowBox[{"v_", ",", "w_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Feistel", "[", 
   RowBox[{"S", ",", 
    RowBox[{"Drop", "[", 
     RowBox[{"kRounds", ",", "1"}], "]"}], ",", 
    RowBox[{"FeistelRound", "[", 
     RowBox[{"S", ",", 
      RowBox[{"kRounds", "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"v", ",", "w"}], "}"}]}], "]"}]}], "]"}]}]], "Input",
 CellLabel->"In[63]:=",ExpressionUUID->"289562b9-d3aa-43c3-aed3-b4a344df13fb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SQ", "[", 
   RowBox[{"{", 
    RowBox[{"x0_", ",", "x1_", ",", "x2_", ",", "x3_"}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"x2", ",", "x3", ",", 
    RowBox[{"x0", "+", 
     RowBox[{"x1", "*", "x2"}]}], ",", 
    RowBox[{"x1", "+", 
     RowBox[{"x2", "*", "x3"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.752396399987412*^9, 3.75239640507544*^9}, {
   3.752397425301484*^9, 3.7523974660537663`*^9}, 3.785253390836918*^9},
 CellLabel->"In[64]:=",ExpressionUUID->"0cc3d9f7-4011-4a35-9f7b-cbff11c6a21d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Q", "[", 
   RowBox[{"k_", ",", 
    RowBox[{"{", 
     RowBox[{"v_", ",", "w_"}], "}"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Feistel", "[", 
    RowBox[{"SQ", ",", 
     RowBox[{"SplitKey", "[", 
      RowBox[{"k", ",", "4"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"v", ",", "w"}], "}"}]}], "]"}], "//", "PModTwo"}]}]], "Input",
 CellChangeTimes->{{3.752397467408245*^9, 3.752397521407137*^9}, {
   3.785253499919832*^9, 3.785253505841916*^9}, 3.785253565094632*^9},
 CellLabel->"In[65]:=",ExpressionUUID->"76c43911-dfb4-44bd-bb84-69787c120745"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Q", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"v0", ",", "v1", ",", "v2", ",", "v3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"w0", ",", "w1", ",", "w2", ",", "w3"}], "}"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.785253447173811*^9, 3.785253462435528*^9}},
 CellLabel->"In[66]:=",ExpressionUUID->"5375b153-fbb3-435f-bfba-dda6d297638e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"w0", ",", "w1", ",", "w2", ",", "w3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"v0", "+", "w2"}], ",", 
     RowBox[{"v1", "+", "w3"}], ",", 
     RowBox[{"v2", "+", "w0", "+", 
      RowBox[{"w1", " ", "w2"}]}], ",", 
     RowBox[{"v3", "+", "w1", "+", 
      RowBox[{"w2", " ", "w3"}]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.785253462768045*^9, {3.785253494899995*^9, 3.785253507923091*^9}, 
   3.7852535671566477`*^9, 3.785256760234439*^9},
 CellLabel->"Out[66]=",ExpressionUUID->"4331783a-f379-4f01-b332-95da3af00852"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"QByte", "[", 
   RowBox[{"k_", ",", "x_"}], "]"}], ":=", 
  RowBox[{"Join", "@@", 
   RowBox[{"Q", "[", 
    RowBox[{"k", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Take", "[", 
        RowBox[{"x", ",", "4"}], "]"}], ",", 
       RowBox[{"Drop", "[", 
        RowBox[{"x", ",", "4"}], "]"}]}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7852534093387012`*^9, 3.785253410431304*^9}, 
   3.7852535123809443`*^9},
 CellLabel->"In[67]:=",ExpressionUUID->"4e853ac5-5bdc-4904-8620-5524313ef8fd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"QZeroByte", "[", "vw_", "]"}], ":=", 
  RowBox[{"QByte", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{"0", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "0", ",", "11"}], "}"}]}], "]"}], ",", "vw"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.785253036009224*^9, 3.78525305573565*^9}},
 CellLabel->"In[68]:=",ExpressionUUID->"0da593bf-c8a0-4c97-89ec-4965652582db"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"QZeroByte", "[", 
      RowBox[{"{", 
       RowBox[{
       "v0", ",", "v1", ",", "v2", ",", "v3", ",", "w0", ",", "w1", ",", "w2",
         ",", "w3"}], "}"}], "]"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"z_", "^", "2"}], "\[RuleDelayed]", "z"}], ",", 
       RowBox[{
        RowBox[{"z_", "^", "3"}], "\[Rule]", "z"}]}], "}"}]}], "//", 
    "PModTwo"}], "//", "Expand"}], ";"}]], "Input",
 CellChangeTimes->{{3.752398536013014*^9, 3.752398548439659*^9}, 
   3.752410687398801*^9, {3.78525280941472*^9, 3.785252856564212*^9}, {
   3.785252971938388*^9, 3.785252987213393*^9}, {3.785253030948608*^9, 
   3.785253061752926*^9}, {3.78525352064063*^9, 3.7852535223225737`*^9}, {
   3.78525357766486*^9, 3.7852537160328693`*^9}},
 CellLabel->"In[69]:=",ExpressionUUID->"47be6b8f-243d-4346-a213-bc2bd0035f8a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"QZ", "[", 
   RowBox[{"{", 
    RowBox[{
    "v0_", ",", "v1_", ",", "v2_", ",", "v3_", ",", "w0_", ",", "w1_", ",", 
     "w2_", ",", "w3_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"v2", "+", 
      RowBox[{"w1", " ", "w2"}]}], ",", 
     RowBox[{"v3", "+", 
      RowBox[{"w2", " ", "w3"}]}], ",", 
     RowBox[{"v0", "+", 
      RowBox[{"v1", " ", "v2"}], "+", 
      RowBox[{"v1", " ", "w0"}], "+", 
      RowBox[{"v1", " ", "w1", " ", "w2"}], "+", 
      RowBox[{"v2", " ", "w3"}], "+", 
      RowBox[{"w0", " ", "w3"}], "+", 
      RowBox[{"w1", " ", "w2", " ", "w3"}]}], ",", 
     RowBox[{"v1", "+", 
      RowBox[{"v2", " ", "v3"}], "+", 
      RowBox[{"v3", " ", "w0"}], "+", 
      RowBox[{"v2", " ", "w1"}], "+", 
      RowBox[{"w0", " ", "w1"}], "+", 
      RowBox[{"w1", " ", "w2"}], "+", 
      RowBox[{"v3", " ", "w1", " ", "w2"}], "+", 
      RowBox[{"v2", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"w0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"w1", " ", "w2", " ", "w3"}]}], ",", 
     RowBox[{
      RowBox[{"v1", " ", "v2"}], "+", 
      RowBox[{"v1", " ", "w0"}], "+", "w2", "+", 
      RowBox[{"v1", " ", "w1", " ", "w2"}], "+", 
      RowBox[{"v2", " ", "w3"}], "+", 
      RowBox[{"w0", " ", "w3"}], "+", 
      RowBox[{"w1", " ", "w2", " ", "w3"}]}], ",", 
     RowBox[{
      RowBox[{"v2", " ", "v3"}], "+", 
      RowBox[{"v3", " ", "w0"}], "+", 
      RowBox[{"v2", " ", "w1"}], "+", 
      RowBox[{"w0", " ", "w1"}], "+", 
      RowBox[{"w1", " ", "w2"}], "+", 
      RowBox[{"v3", " ", "w1", " ", "w2"}], "+", "w3", "+", 
      RowBox[{"v2", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"w0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"w1", " ", "w2", " ", "w3"}]}], ",", 
     RowBox[{
      RowBox[{"v0", " ", "v3"}], "+", 
      RowBox[{"v1", " ", "v2", " ", "v3"}], "+", "w0", "+", 
      RowBox[{"v1", " ", "v3", " ", "w0"}], "+", 
      RowBox[{"v1", " ", "v3", " ", "w1", " ", "w2"}], "+", 
      RowBox[{"v2", " ", "v3", " ", "w3"}], "+", 
      RowBox[{"v3", " ", "w0", " ", "w3"}], "+", 
      RowBox[{"v0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v2", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v1", " ", "v2", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"w0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v1", " ", "w0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"w1", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v1", " ", "w1", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v3", " ", "w1", " ", "w2", " ", "w3"}]}], ",", 
     RowBox[{
      RowBox[{"v0", " ", "v1"}], "+", 
      RowBox[{"v1", " ", "v2"}], "+", 
      RowBox[{"v0", " ", "v2", " ", "v3"}], "+", 
      RowBox[{"v1", " ", "v2", " ", "v3"}], "+", 
      RowBox[{"v1", " ", "w0"}], "+", 
      RowBox[{"v0", " ", "v3", " ", "w0"}], "+", 
      RowBox[{"v1", " ", "v3", " ", "w0"}], "+", "w1", "+", 
      RowBox[{"v0", " ", "v2", " ", "w1"}], "+", 
      RowBox[{"v1", " ", "v2", " ", "w1"}], "+", 
      RowBox[{"v0", " ", "w0", " ", "w1"}], "+", 
      RowBox[{"v1", " ", "w0", " ", "w1"}], "+", 
      RowBox[{"v0", " ", "w1", " ", "w2"}], "+", 
      RowBox[{"v0", " ", "v3", " ", "w1", " ", "w2"}], "+", 
      RowBox[{"v1", " ", "v3", " ", "w1", " ", "w2"}], "+", 
      RowBox[{"v1", " ", "v2", " ", "w3"}], "+", 
      RowBox[{"v2", " ", "v3", " ", "w3"}], "+", 
      RowBox[{"v1", " ", "w0", " ", "w3"}], "+", 
      RowBox[{"v3", " ", "w0", " ", "w3"}], "+", 
      RowBox[{"v2", " ", "w1", " ", "w3"}], "+", 
      RowBox[{"w0", " ", "w1", " ", "w3"}], "+", 
      RowBox[{"v2", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v0", " ", "v2", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v1", " ", "v2", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"w0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v0", " ", "w0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v1", " ", "w0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v0", " ", "w1", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v3", " ", "w1", " ", "w2", " ", "w3"}]}]}], "}"}], "//", 
   "ModTwo"}]}]], "Input",
 CellChangeTimes->{{3.785253698825189*^9, 3.7852537102209883`*^9}, {
  3.785253744089602*^9, 3.785253745694127*^9}},
 CellLabel->"In[70]:=",ExpressionUUID->"7357874c-9e52-4f83-9a05-0693500728de"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"QZ", "[", 
  RowBox[{"{", 
   RowBox[{
   "v0", ",", "v1", ",", "v2", ",", "v3", ",", "w0", ",", "w1", ",", "w2", 
    ",", "w3"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.785253678032837*^9, 3.785253683581912*^9}},
 CellLabel->"In[71]:=",ExpressionUUID->"07698c25-2916-4288-a17b-dd8b7d3a379d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"v2", "+", 
      RowBox[{"w1", " ", "w2"}]}], ",", "2"}], "]"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"v3", "+", 
      RowBox[{"w2", " ", "w3"}]}], ",", "2"}], "]"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"v0", "+", 
      RowBox[{"v1", " ", "v2"}], "+", 
      RowBox[{"v1", " ", "w0"}], "+", 
      RowBox[{"v1", " ", "w1", " ", "w2"}], "+", 
      RowBox[{"v2", " ", "w3"}], "+", 
      RowBox[{"w0", " ", "w3"}], "+", 
      RowBox[{"w1", " ", "w2", " ", "w3"}]}], ",", "2"}], "]"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"v1", "+", 
      RowBox[{"v2", " ", "v3"}], "+", 
      RowBox[{"v3", " ", "w0"}], "+", 
      RowBox[{"v2", " ", "w1"}], "+", 
      RowBox[{"w0", " ", "w1"}], "+", 
      RowBox[{"w1", " ", "w2"}], "+", 
      RowBox[{"v3", " ", "w1", " ", "w2"}], "+", 
      RowBox[{"v2", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"w0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"w1", " ", "w2", " ", "w3"}]}], ",", "2"}], "]"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"v1", " ", "v2"}], "+", 
      RowBox[{"v1", " ", "w0"}], "+", "w2", "+", 
      RowBox[{"v1", " ", "w1", " ", "w2"}], "+", 
      RowBox[{"v2", " ", "w3"}], "+", 
      RowBox[{"w0", " ", "w3"}], "+", 
      RowBox[{"w1", " ", "w2", " ", "w3"}]}], ",", "2"}], "]"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"v2", " ", "v3"}], "+", 
      RowBox[{"v3", " ", "w0"}], "+", 
      RowBox[{"v2", " ", "w1"}], "+", 
      RowBox[{"w0", " ", "w1"}], "+", 
      RowBox[{"w1", " ", "w2"}], "+", 
      RowBox[{"v3", " ", "w1", " ", "w2"}], "+", "w3", "+", 
      RowBox[{"v2", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"w0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"w1", " ", "w2", " ", "w3"}]}], ",", "2"}], "]"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"v0", " ", "v3"}], "+", 
      RowBox[{"v1", " ", "v2", " ", "v3"}], "+", "w0", "+", 
      RowBox[{"v1", " ", "v3", " ", "w0"}], "+", 
      RowBox[{"v1", " ", "v3", " ", "w1", " ", "w2"}], "+", 
      RowBox[{"v2", " ", "v3", " ", "w3"}], "+", 
      RowBox[{"v3", " ", "w0", " ", "w3"}], "+", 
      RowBox[{"v0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v2", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v1", " ", "v2", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"w0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v1", " ", "w0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"w1", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v1", " ", "w1", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v3", " ", "w1", " ", "w2", " ", "w3"}]}], ",", "2"}], "]"}], 
   ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"v0", " ", "v1"}], "+", 
      RowBox[{"v1", " ", "v2"}], "+", 
      RowBox[{"v0", " ", "v2", " ", "v3"}], "+", 
      RowBox[{"v1", " ", "v2", " ", "v3"}], "+", 
      RowBox[{"v1", " ", "w0"}], "+", 
      RowBox[{"v0", " ", "v3", " ", "w0"}], "+", 
      RowBox[{"v1", " ", "v3", " ", "w0"}], "+", "w1", "+", 
      RowBox[{"v0", " ", "v2", " ", "w1"}], "+", 
      RowBox[{"v1", " ", "v2", " ", "w1"}], "+", 
      RowBox[{"v0", " ", "w0", " ", "w1"}], "+", 
      RowBox[{"v1", " ", "w0", " ", "w1"}], "+", 
      RowBox[{"v0", " ", "w1", " ", "w2"}], "+", 
      RowBox[{"v0", " ", "v3", " ", "w1", " ", "w2"}], "+", 
      RowBox[{"v1", " ", "v3", " ", "w1", " ", "w2"}], "+", 
      RowBox[{"v1", " ", "v2", " ", "w3"}], "+", 
      RowBox[{"v2", " ", "v3", " ", "w3"}], "+", 
      RowBox[{"v1", " ", "w0", " ", "w3"}], "+", 
      RowBox[{"v3", " ", "w0", " ", "w3"}], "+", 
      RowBox[{"v2", " ", "w1", " ", "w3"}], "+", 
      RowBox[{"w0", " ", "w1", " ", "w3"}], "+", 
      RowBox[{"v2", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v0", " ", "v2", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v1", " ", "v2", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"w0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v0", " ", "w0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v1", " ", "w0", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v0", " ", "w1", " ", "w2", " ", "w3"}], "+", 
      RowBox[{"v3", " ", "w1", " ", "w2", " ", "w3"}]}], ",", "2"}], "]"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.785253683887909*^9, {3.785253725815845*^9, 3.785253747739871*^9}, 
   3.78525676044921*^9},
 CellLabel->"Out[71]=",ExpressionUUID->"305c0a50-f586-4aa6-a37c-d939b1b35d7c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example 6.2 and Problem Sheet 9 Question 7", "Subsection",
 CellChangeTimes->{{3.785254754629368*^9, 
  3.785254764991561*^9}},ExpressionUUID->"210d620d-703b-4368-871a-\
6b2b7c177dd5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"L", "[", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", "QZ"}], "]"}], "[", 
  RowBox[{"{", 
   RowBox[{
   "v0", ",", "v1", ",", "v2", ",", "v3", ",", "w0", ",", "w1", ",", "w2", 
    ",", "w3"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.7852567277613707`*^9, 3.7852567280319033`*^9}},
 CellLabel->"In[72]:=",ExpressionUUID->"abd4311f-e9bd-4ea9-8cb4-2f47ac6672c5"],

Cell[BoxData[
 RowBox[{"Mod", "[", 
  RowBox[{
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"v2", "+", 
      RowBox[{"w1", " ", "w2"}]}], ",", "2"}], "]"}], ",", "2"}], 
  "]"}]], "Output",
 CellChangeTimes->{3.785256728341537*^9, 3.785256760689356*^9},
 CellLabel->"Out[72]=",ExpressionUUID->"75ca8a1d-5d17-48a3-ba84-85a0721da069"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NonZeroCorrelations", "[", 
  RowBox[{"8", ",", 
   RowBox[{"L", "[", 
    RowBox[{
     RowBox[{"{", "0", "}"}], ",", "QZ"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.785254047651849*^9, 3.7852541038375263`*^9}, {
  3.785254177352931*^9, 3.785254177945488*^9}},
 CellLabel->"In[73]:=",ExpressionUUID->"4f6d0cc5-42d3-462d-bf24-e41bf71887b0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "5"}], "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "6"}], "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "5", ",", "6"}], "}"}], ",", 
     RowBox[{"-", 
      FractionBox["1", "2"]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.785254054273456*^9, 3.785254081635931*^9}, {
   3.785254175022356*^9, 3.785254181743886*^9}, 3.7852567650476427`*^9},
 CellLabel->"Out[73]=",ExpressionUUID->"574b4b08-6a3f-4347-80cc-33c9367dcafa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"L", "[", 
   RowBox[{
    RowBox[{"{", "2", "}"}], ",", "QZ"}], "]"}], "[", 
  RowBox[{"{", 
   RowBox[{
   "v0", ",", "v1", ",", "v2", ",", "v3", ",", "w0", ",", "w1", ",", "w2", 
    ",", "w3"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.785254979124413*^9, 3.785254987973954*^9}, {
  3.785256718554241*^9, 3.78525671862191*^9}},
 CellLabel->"In[74]:=",ExpressionUUID->"9023732f-e958-4dc4-9133-46b856ec4660"],

Cell[BoxData[
 RowBox[{"Mod", "[", 
  RowBox[{
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"v0", "+", 
      RowBox[{"v1", " ", "v2"}], "+", 
      RowBox[{"v1", " ", "w0"}], "+", 
      RowBox[{"v1", " ", "w1", " ", "w2"}], "+", 
      RowBox[{"v2", " ", "w3"}], "+", 
      RowBox[{"w0", " ", "w3"}], "+", 
      RowBox[{"w1", " ", "w2", " ", "w3"}]}], ",", "2"}], "]"}], ",", "2"}], 
  "]"}]], "Output",
 CellChangeTimes->{3.7852549883174753`*^9, 3.7852567195423613`*^9, 
  3.785256765332438*^9},
 CellLabel->"Out[74]=",ExpressionUUID->"4e41b66e-9de7-4e51-a04c-8d326b21e2bd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NonZeroCorrelations", "[", 
  RowBox[{"8", ",", 
   RowBox[{"L", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", "QZ"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{3.785254807850595*^9},
 CellLabel->"In[75]:=",ExpressionUUID->"96dfeb83-43ee-4c59-89eb-98ec1153db35"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "3", "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "6"}], "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "7"}], "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "7"}], "}"}], ",", 
     RowBox[{"-", 
      FractionBox["1", "2"]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.785254812393577*^9, 3.7852567688791637`*^9},
 CellLabel->"Out[75]=",ExpressionUUID->"8eda127b-b638-4d32-b6e6-5ed61324dbb2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NonZeroCorrelations", "[", 
  RowBox[{"8", ",", 
   RowBox[{"L", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "QZ"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.785255485623177*^9, 3.78525548570748*^9}},
 CellLabel->"In[76]:=",ExpressionUUID->"943fe33b-b2b3-40b6-9b0c-1cef98756f27"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "0", "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "7"}], "}"}], ",", 
     FractionBox["1", "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "4"}], "}"}], ",", 
     FractionBox["1", "4"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "4", ",", "5"}], "}"}], ",", 
     FractionBox["1", "4"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "4", ",", "6"}], "}"}], ",", 
     FractionBox["1", "4"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2", ",", "4", ",", "7"}], "}"}], ",", 
     RowBox[{"-", 
      FractionBox["1", "4"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", "4", ",", "5", ",", "6"}], "}"}], ",", 
     RowBox[{"-", 
      FractionBox["1", "4"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2", ",", "4", ",", "5", ",", "7"}], "}"}], 
     ",", 
     RowBox[{"-", 
      FractionBox["1", "4"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2", ",", "4", ",", "6", ",", "7"}], "}"}], 
     ",", 
     RowBox[{"-", 
      FractionBox["1", "4"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "2", ",", "4", ",", "5", ",", "6", ",", "7"}], 
      "}"}], ",", 
     FractionBox["1", "4"]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.785255489655837*^9, 3.785256772512993*^9},
 CellLabel->"Out[76]=",ExpressionUUID->"1d599745-cb4e-4807-8b5f-529f8cf173df"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{958, 835},
WindowMargins->{{Automatic, -1281}, {Automatic, 0}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 215, 5, 67, "Section",ExpressionUUID->"ae22d33f-1f22-44fa-8417-0e0d9f552085"],
Cell[798, 29, 423, 8, 81, "Subsection",ExpressionUUID->"b9c93934-07a6-4940-8a19-27da951d267e"],
Cell[CellGroupData[{
Cell[1246, 41, 161, 3, 38, "Subsection",ExpressionUUID->"a39d5536-b698-40e6-a709-a52766484602"],
Cell[1410, 46, 327, 7, 30, "Input",ExpressionUUID->"e427eb19-7eb2-4d44-8247-9676f2f20856"],
Cell[1740, 55, 276, 6, 30, "Input",ExpressionUUID->"9f22a1c1-538c-4919-a2f6-a7b7616b2e42"],
Cell[2019, 63, 845, 23, 73, "Input",ExpressionUUID->"2c0d92d4-d2af-4017-a58a-692abe861c9e"],
Cell[2867, 88, 896, 21, 30, "Input",ExpressionUUID->"25b08814-6103-41b8-b6ea-6806b910cd38"],
Cell[3766, 111, 808, 18, 30, "Input",ExpressionUUID->"a61b1368-e3fc-45f1-a664-9803fea546f2"],
Cell[4577, 131, 282, 6, 30, "Input",ExpressionUUID->"2291904e-025b-47af-ac2b-dc5abaad8f6e"],
Cell[4862, 139, 263, 5, 30, "Input",ExpressionUUID->"b30ba8c5-3237-45f0-8155-448144a83488"],
Cell[5128, 146, 320, 8, 30, "Input",ExpressionUUID->"583c4e71-8ba9-4a43-9851-d31003bded6c"],
Cell[5451, 156, 693, 18, 30, "Input",ExpressionUUID->"8c3e8b2e-29ba-4577-98f1-f0cae9f3872c"],
Cell[CellGroupData[{
Cell[6169, 178, 298, 6, 30, "Input",ExpressionUUID->"b9f9614d-3896-4772-a98f-ee0f0968f1a1"],
Cell[6470, 186, 674, 18, 34, "Output",ExpressionUUID->"a483f38c-b1c1-42bd-96e3-278d61259e2b"]
}, Open  ]],
Cell[7159, 207, 340, 7, 30, "Input",ExpressionUUID->"8b7e58d2-eb0f-43cb-93de-cfd25fd04f4c"],
Cell[7502, 216, 383, 9, 30, "Input",ExpressionUUID->"1cb12a99-5d70-4935-9f96-64ad2cb9aff9"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7934, 231, 226, 4, 67, "Section",ExpressionUUID->"c801f799-a4d7-4f83-984f-f401215ed901"],
Cell[CellGroupData[{
Cell[8185, 239, 337, 7, 54, "Subsection",ExpressionUUID->"4ab90683-c46d-4c9c-be7e-a12fa4ad2260"],
Cell[8525, 248, 1016, 22, 30, "Input",ExpressionUUID->"8ffe7ced-fc0c-4f3a-90e5-04522b1db34f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9578, 275, 159, 3, 54, "Subsection",ExpressionUUID->"5e9c0adc-f309-429b-afdf-f4c4fa4fbe0b"],
Cell[9740, 280, 842, 25, 30, "Input",ExpressionUUID->"f119b5df-b400-4958-9f3f-c5fbaf0592d8"],
Cell[10585, 307, 856, 22, 30, "Input",ExpressionUUID->"03def9c3-a9e8-4223-a884-a1bbdb6a1f0f"],
Cell[11444, 331, 542, 15, 30, "Input",ExpressionUUID->"70020611-85f6-4ecc-9a6a-1dc7c5d957e2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12023, 351, 336, 5, 54, "Subsection",ExpressionUUID->"a95516c8-47be-482f-8acb-0a8e0e6ab165"],
Cell[12362, 358, 439, 11, 30, "Input",ExpressionUUID->"5eb956d6-a2de-4bb6-acac-f5756c80a9a0"],
Cell[CellGroupData[{
Cell[12826, 373, 839, 23, 30, "Input",ExpressionUUID->"d048e2b5-00dc-452f-ab91-301a89c9df7e"],
Cell[13668, 398, 3700, 105, 187, "Output",ExpressionUUID->"eac2f6d3-eb53-483b-a84c-e0e390e161c7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17405, 508, 251, 4, 30, "Input",ExpressionUUID->"d62a42ba-37a4-49c2-a8ed-0dc89fdf585b"],
Cell[17659, 514, 722, 23, 50, "Output",ExpressionUUID->"66e0db07-219c-4349-b2cf-b56a07d88ad0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18418, 542, 168, 3, 45, "Subsubsection",ExpressionUUID->"d6d426b7-f11c-407c-9649-f9959c3888cd"],
Cell[CellGroupData[{
Cell[18611, 549, 1644, 49, 73, "Input",ExpressionUUID->"8242e8d2-40e2-4996-b56a-44be2a171fa0"],
Cell[20258, 600, 2161, 70, 170, "Output",ExpressionUUID->"59a309df-9aa6-4235-92f2-9907578c26f2"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[22480, 677, 258, 4, 54, "Subsection",ExpressionUUID->"16e432a1-5051-480c-91a5-9aa6389df5b7"],
Cell[22741, 683, 500, 12, 30, "Input",ExpressionUUID->"c7aa219a-a20b-4b86-92f8-2f0330dbb248"],
Cell[CellGroupData[{
Cell[23266, 699, 720, 20, 30, "Input",ExpressionUUID->"43e8cdf9-0780-45f3-b173-800b15a4a1dc"],
Cell[23989, 721, 3484, 106, 215, "Output",ExpressionUUID->"a22a6406-3074-4b7b-b200-241ae09811cd"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[27522, 833, 180, 3, 54, "Subsection",ExpressionUUID->"dc9c50bf-4e8a-4a91-9a67-a80b8ac96a8d"],
Cell[27705, 838, 362, 9, 30, "Input",ExpressionUUID->"873e97ac-2c4d-4c1c-b5bb-8916bd4db7bb"],
Cell[CellGroupData[{
Cell[28092, 851, 783, 22, 30, "Input",ExpressionUUID->"fb8d3a61-9cc5-46b7-a4b9-927545aeed65"],
Cell[28878, 875, 2377, 68, 115, "Output",ExpressionUUID->"7115d687-4ee6-4fa2-a517-2b3b4aeb85d0"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31304, 949, 286, 4, 54, "Subsection",ExpressionUUID->"d2b758a7-4e90-4a2f-b779-af4faa118837"],
Cell[31593, 955, 208, 3, 30, "Input",ExpressionUUID->"926dc66f-d676-4e82-b7be-309728d1ec67"],
Cell[31804, 960, 349, 7, 30, "Input",ExpressionUUID->"558a5615-f583-42f7-b2fa-a15567e767cc"],
Cell[32156, 969, 171, 2, 30, "Input",ExpressionUUID->"e3ce6dea-3c91-454a-8562-4d7554ef3494"],
Cell[CellGroupData[{
Cell[32352, 975, 296, 7, 30, "Input",ExpressionUUID->"319a27a0-d144-4c09-a142-454d006e3802"],
Cell[32651, 984, 2405, 74, 68, "Output",ExpressionUUID->"07c8c301-87ba-4889-b049-57638bee105a"]
}, Open  ]],
Cell[35071, 1061, 603, 17, 30, "Input",ExpressionUUID->"6332ae9d-49dc-42da-9ee1-bb78adec2257"],
Cell[CellGroupData[{
Cell[35699, 1082, 721, 20, 30, "Input",ExpressionUUID->"93a5bba6-a0a7-4cab-9547-18fcbbb19020"],
Cell[36423, 1104, 5820, 179, 415, "Output",ExpressionUUID->"c515bd84-d37d-4328-a28b-c361399afc5f"]
}, Open  ]],
Cell[42258, 1286, 813, 23, 30, "Input",ExpressionUUID->"df7ab3cb-43e6-41dd-b1d4-b0bd0c592701"],
Cell[CellGroupData[{
Cell[43096, 1313, 374, 8, 30, "Input",ExpressionUUID->"c0e03015-39b9-4556-a2f6-c0d2fb1a03e8"],
Cell[43473, 1323, 7585, 237, 68, "Output",ExpressionUUID->"78361615-df4f-46f7-aea9-2c10454113e1"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[51107, 1566, 179, 3, 54, "Subsection",ExpressionUUID->"62e2ca63-c74f-433c-999b-5e552a2677c6"],
Cell[51289, 1571, 313, 7, 30, "Input",ExpressionUUID->"8653b510-5f51-46ce-b1bb-60a52ab6f56b"],
Cell[CellGroupData[{
Cell[51627, 1582, 210, 3, 30, "Input",ExpressionUUID->"54571196-ecc0-46b3-9b6d-e42edfa95d6d"],
Cell[51840, 1587, 308, 5, 34, "Output",ExpressionUUID->"f797064b-e172-4d21-997a-3e52d23c23f5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[52185, 1597, 286, 5, 30, "Input",ExpressionUUID->"7c78a3af-8035-485f-80ca-af851768151b"],
Cell[52474, 1604, 1254, 40, 50, "Output",ExpressionUUID->"4b0a90c7-5d58-4991-afab-3a7452cd4333"]
}, Open  ]],
Cell[53743, 1647, 337, 8, 30, "Input",ExpressionUUID->"417a12dc-9e02-44c0-baac-74367c9f2243"],
Cell[CellGroupData[{
Cell[54105, 1659, 233, 4, 30, "Input",ExpressionUUID->"9a5a20ee-5019-4bf7-9dc1-9345009384ce"],
Cell[54341, 1665, 1225, 39, 50, "Output",ExpressionUUID->"c01ea11d-3851-4d68-8bd6-11e1ce0c9ecc"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[55627, 1711, 243, 4, 67, "Section",ExpressionUUID->"8c2631f2-bf59-442c-9dc8-8401af448338"],
Cell[55873, 1717, 668, 19, 30, "Input",ExpressionUUID->"a1eca3f7-df40-4d7a-806e-611aabef109f"],
Cell[56544, 1738, 586, 17, 30, "Input",ExpressionUUID->"0bc97073-8470-486a-85d0-3bb038bc3467"],
Cell[57133, 1757, 999, 24, 30, "Input",ExpressionUUID->"0ea16a39-3f2f-4f75-87d3-b614c6b5c635"],
Cell[58135, 1783, 588, 16, 30, "Input",ExpressionUUID->"9640ed0a-d6e6-4813-bb80-60ecc8c05507"],
Cell[CellGroupData[{
Cell[58748, 1803, 217, 4, 54, "Subsection",ExpressionUUID->"ed1bd9d3-b2c7-4b73-abcd-a7d8857fd977"],
Cell[58968, 1809, 403, 10, 30, "Input",ExpressionUUID->"831313e6-50da-4325-adb5-efcb05ecb795"],
Cell[CellGroupData[{
Cell[59396, 1823, 559, 9, 30, "Input",ExpressionUUID->"82fba150-d0a4-48d0-bfdc-c4af1bb7d8d3"],
Cell[59958, 1834, 1111, 34, 110, "Output",ExpressionUUID->"8c5dcc3e-f961-4979-bf16-ed804aba9dd5"]
}, Open  ]],
Cell[61084, 1871, 651, 15, 30, "Input",ExpressionUUID->"c23e937d-0478-4202-8cd3-2519975258c1"],
Cell[CellGroupData[{
Cell[61760, 1890, 371, 7, 30, "Input",ExpressionUUID->"36a4e087-c2e0-4d59-91eb-9c3f390f9583"],
Cell[62134, 1899, 1160, 37, 110, "Output",ExpressionUUID->"dab147a0-5767-492f-a521-249c4a737428"]
}, Open  ]],
Cell[63309, 1939, 355, 9, 30, "Input",ExpressionUUID->"87b2433d-3a62-457e-9e7b-a7e852719880"],
Cell[CellGroupData[{
Cell[63689, 1952, 324, 6, 30, "Input",ExpressionUUID->"0f101de3-98b1-422d-92e2-3cfea3872882"],
Cell[64016, 1960, 890, 26, 94, "Output",ExpressionUUID->"9584da2e-c58f-49d1-812f-47831c0c9b8e"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[64955, 1992, 222, 4, 54, "Subsection",ExpressionUUID->"1af19bbe-0bfa-4eef-ab0d-d950d40625c3"],
Cell[CellGroupData[{
Cell[65202, 2000, 794, 20, 52, "Input",ExpressionUUID->"f559afa6-a697-4aca-9e7d-b753ef8504d0"],
Cell[65999, 2022, 3935, 119, 99, "Output",ExpressionUUID->"e4288f26-ca77-4faa-8245-5e6a1acbd049"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[69983, 2147, 181, 3, 54, "Subsection",ExpressionUUID->"c7e28223-1ad8-45e1-af55-08ec44affc8d"],
Cell[70167, 2152, 209, 3, 30, "Input",ExpressionUUID->"751b545a-6e98-4faa-8514-fb0adaa28fab"],
Cell[70379, 2157, 580, 14, 30, "Input",ExpressionUUID->"a28829cf-6894-495d-9d25-34485aee96d2"],
Cell[CellGroupData[{
Cell[70984, 2175, 402, 7, 30, "Input",ExpressionUUID->"ab49c265-4003-40cb-9692-12a82395dd52"],
Cell[71389, 2184, 1344, 35, 56, "Output",ExpressionUUID->"71e11971-4293-4118-bfa3-e399739ba34c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[72770, 2224, 439, 8, 30, "Input",ExpressionUUID->"5a0f4215-bffd-47db-89e2-a065be192860"],
Cell[73212, 2234, 3632, 100, 394, "Output",ExpressionUUID->"68308119-9880-4ef3-b293-574340073383"]
}, Open  ]],
Cell[76859, 2337, 377, 8, 30, "Input",ExpressionUUID->"eba61130-1faa-48d7-85a5-c08b933a50dd"],
Cell[CellGroupData[{
Cell[77261, 2349, 328, 6, 30, "Input",ExpressionUUID->"b738befd-f788-438a-8379-90d7aabb2f7c"],
Cell[77592, 2357, 1053, 33, 34, "Output",ExpressionUUID->"9867b921-f2f7-470d-ba9a-3781320d7d62"]
}, Open  ]],
Cell[CellGroupData[{
Cell[78682, 2395, 852, 22, 52, "Input",ExpressionUUID->"d4e05873-8297-4815-9f78-c8c6636e51ee"],
Cell[79537, 2419, 13603, 423, 827, "Output",ExpressionUUID->"2e0af690-c799-4bbc-ba06-33a8e2e170ec"]
}, Open  ]],
Cell[CellGroupData[{
Cell[93177, 2847, 697, 16, 30, "Input",ExpressionUUID->"cb80f305-11ba-4f81-b6a4-ebadfc71cb26"],
Cell[93877, 2865, 12703, 356, 803, "Output",ExpressionUUID->"8e2a8d25-1b15-45f9-b365-2335f95b526c"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[106629, 3227, 247, 6, 54, "Subsection",ExpressionUUID->"86d6cb13-b837-46a6-b8f0-97df2d28a484"],
Cell[CellGroupData[{
Cell[106901, 3237, 262, 5, 30, "Input",ExpressionUUID->"ba61c24b-5cd7-4728-85d9-f48fd5072b6d"],
Cell[107166, 3244, 2242, 52, 298, "Output",ExpressionUUID->"1e88555f-6efe-4f9b-ba78-ba90fdf82d6b"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[109469, 3303, 243, 4, 67, "Section",ExpressionUUID->"f8d1de75-1299-4872-a0e5-a6513c7634c1"],
Cell[109715, 3309, 264, 6, 45, "Subsubsection",ExpressionUUID->"9a1f1316-0c3b-4bcf-b156-4a38cf95afdc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[110016, 3320, 221, 4, 67, "Section",ExpressionUUID->"21815a01-0083-4715-9b67-b816d593b40e"],
Cell[110240, 3326, 292, 7, 30, "Input",ExpressionUUID->"713928f0-0a79-45f1-bc3f-6add4cccdbd0"],
Cell[110535, 3335, 573, 15, 30, "Input",ExpressionUUID->"e2a1257d-07b9-4f8f-957d-f6cbdedb1ec4"],
Cell[111111, 3352, 343, 8, 30, "Input",ExpressionUUID->"2a6917be-7da0-4ebd-9d51-bcb28c618ad4"],
Cell[CellGroupData[{
Cell[111479, 3364, 199, 3, 45, "Subsubsection",ExpressionUUID->"3b8d0733-d057-479b-8e28-ee019a218146"],
Cell[111681, 3369, 539, 13, 30, "Input",ExpressionUUID->"12338bb6-99ec-41b8-9a12-64ff6820334b"],
Cell[112223, 3384, 317, 9, 30, "Input",ExpressionUUID->"ecd468ec-f7af-4653-b0b9-f459f8ce0534"],
Cell[112543, 3395, 589, 16, 30, "Input",ExpressionUUID->"289562b9-d3aa-43c3-aed3-b4a344df13fb"],
Cell[113135, 3413, 551, 13, 30, "Input",ExpressionUUID->"0cc3d9f7-4011-4a35-9f7b-cbff11c6a21d"],
Cell[113689, 3428, 592, 15, 30, "Input",ExpressionUUID->"76c43911-dfb4-44bd-bb84-69787c120745"],
Cell[CellGroupData[{
Cell[114306, 3447, 497, 13, 30, "Input",ExpressionUUID->"5375b153-fbb3-435f-bfba-dda6d297638e"],
Cell[114806, 3462, 625, 16, 34, "Output",ExpressionUUID->"4331783a-f379-4f01-b332-95da3af00852"]
}, Open  ]],
Cell[115446, 3481, 547, 15, 30, "Input",ExpressionUUID->"4e853ac5-5bdc-4904-8620-5524313ef8fd"],
Cell[115996, 3498, 419, 11, 30, "Input",ExpressionUUID->"0da593bf-c8a0-4c97-89ec-4965652582db"],
Cell[116418, 3511, 916, 22, 30, "Input",ExpressionUUID->"47be6b8f-243d-4346-a213-bc2bd0035f8a"],
Cell[117337, 3535, 4268, 95, 241, "Input",ExpressionUUID->"7357874c-9e52-4f83-9a05-0693500728de"],
Cell[CellGroupData[{
Cell[121630, 3634, 324, 7, 30, "Input",ExpressionUUID->"07698c25-2916-4288-a17b-dd8b7d3a379d"],
Cell[121957, 3643, 4498, 106, 203, "Output",ExpressionUUID->"305c0a50-f586-4aa6-a37c-d939b1b35d7c"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[126504, 3755, 190, 3, 54, "Subsection",ExpressionUUID->"210d620d-703b-4368-871a-6b2b7c177dd5"],
Cell[CellGroupData[{
Cell[126719, 3762, 405, 10, 30, "Input",ExpressionUUID->"abd4311f-e9bd-4ea9-8cb4-2f47ac6672c5"],
Cell[127127, 3774, 338, 9, 34, "Output",ExpressionUUID->"75ca8a1d-5d17-48a3-ba84-85a0721da069"]
}, Open  ]],
Cell[CellGroupData[{
Cell[127502, 3788, 372, 8, 30, "Input",ExpressionUUID->"4f6d0cc5-42d3-462d-bf24-e41bf71887b0"],
Cell[127877, 3798, 821, 25, 50, "Output",ExpressionUUID->"574b4b08-6a3f-4347-80cc-33c9367dcafa"]
}, Open  ]],
Cell[CellGroupData[{
Cell[128735, 3828, 449, 11, 30, "Input",ExpressionUUID->"9023732f-e958-4dc4-9133-46b856ec4660"],
Cell[129187, 3841, 584, 15, 34, "Output",ExpressionUUID->"4e41b66e-9de7-4e51-a04c-8d326b21e2bd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[129808, 3861, 297, 7, 30, "Input",ExpressionUUID->"96dfeb83-43ee-4c59-89eb-98ec1153db35"],
Cell[130108, 3870, 747, 24, 50, "Output",ExpressionUUID->"8eda127b-b638-4d32-b6e6-5ed61324dbb2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[130892, 3899, 320, 7, 30, "Input",ExpressionUUID->"943fe33b-b2b3-40b6-9b0c-1cef98756f27"],
Cell[131215, 3908, 1893, 61, 88, "Output",ExpressionUUID->"1d599745-cb4e-4807-8b5f-529f8cf173df"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

